%define mpi_family openmpi3
%define compiler_family gnu7
#----------------------------------------------------------------------------bh-
# This RPM .spec file is part of the OpenHPC project.
#
# It may have been modified from the default version supplied by the underlying
# release package (if available) in order to apply patches, perform customized
# build/install configurations, and supply additional files to support
# desired integration conventions.
#
#----------------------------------------------------------------------------eh-

# Build that is dependent on compiler/mpi toolchains
%define ohpc_compiler_dependent 1
%define ohpc_mpi_dependent 1
%include %{_sourcedir}/OHPC_macros

# Base package name
%define pname extrae
%define PNAME %(echo %{pname} | tr [a-z] [A-Z])

Summary:	Extrae tool
Name:		%{pname}-%{compiler_family}-%{mpi_family}%{PROJ_DELIM}
Version:	3.5.2
Release:	79.1
License:	GNU
Group:		%{PROJ_NAME}/perf-tools
URL:		https://tools.bsc.es
Source0:	https://ftp.tools.bsc.es/extrae/extrae-%{version}-src.tar.bz2
Source1:	OHPC_macros



BuildRequires: autoconf%{PROJ_DELIM}
BuildRequires: automake%{PROJ_DELIM}
BuildRequires: libtool%{PROJ_DELIM}
BuildRequires: binutils-devel
BuildRequires: libxml2-devel
BuildRequires: libunwind-devel
Requires: libunwind-devel


%if 0%{?sles_version} || 0%{?suse_version}
BuildRequires: prun%{PROJ_DELIM}
%endif

%ifarch x86_64
BuildRequires: papi%{PROJ_DELIM}
BuildRequires: infinipath-psm
Requires: papi%{PROJ_DELIM}
%endif

BuildRequires: boost-%{compiler_family}-%{mpi_family}%{PROJ_DELIM}

# Default library install path
%define install_path %{OHPC_LIBS}/%{compiler_family}/%{mpi_family}/%{pname}/%version

%description
Extrae is the package devoted to generate Paraver trace-files for a post-mortem analysis. Extrae is a tool that uses different interposition mechanisms to inject probes into the target application so as to gather information regarding the application performance.

This is the %{compiler_family}-%{mpi_family} version.

%prep
%setup -q -n %{pname}-%{version}


%build
#export BUILDING_RPM=true

# OpenHPC compiler/mpi designation
%ohpc_setup_compiler
module load boost

%ifarch x86_64
module load papi
%endif

%ifarch x86_64
CONFIGURE_OPTIONS="$CONFIGURE_OPTIONS --with-papi=$PAPI_DIR "
%else
CONFIGURE_OPTIONS="$CONFIGURE_OPTIONS --without-papi " 
%endif

#unwind section
CONFIGURE_OPTIONS="$CONFIGURE_OPTIONS --with-unwind=/usr/lib64 "

CONFIGURE_OPTIONS="$CONFIGURE_OPTIONS --with-unwind-headers=/usr/include "

CONFIGURE_OPTIONS="$CONFIGURE_OPTIONS --with-unwind-libs=/usr/lib64 "



./configure --prefix=%{install_path} --enable-posix-clock --with-mpi=$MPI_DIR --with-boost=$BOOST_DIR --without-dyninst --disable-online $CONFIGURE_OPTIONS


#--with-binutils
#Si no pilla el de sistema -> --with-xml-prefix



make %{?_smp_mflags} 


#./configure --prefix=/apps/BSCTOOLS/extrae/3.5.2/impi_2017_4 --enable-posix-clock --with-binutils=/apps/BSCTOOLS/deps/binutils/2.28
#--with-boost=/apps/BSCTOOLS/deps/boost/1.64.0 --without-cuda --with-dwarf=/apps/BSCTOOLS/deps/libdwarf/20170709 
#--with-dyninst=/apps/BSCTOOLS/deps/dyninst/9.3.2 --with-elf=/apps/BSCTOOLS/deps/libelf/0.169 --enable-instrument-io 
#--enable-instrument-dynamic-memory --with-java-jdk=/apps/JDK/8u131 --without-memkind --enable-merge-in-trace 
#--with-mpi=/apps/INTEL/2017.4/impi/2017.3.196 --disable-online --without-opencl --enable-openmp 
#--with-papi=/apps/BSCTOOLS/deps/papi/5.5.1 --enable-pebs-sampling --enable-sampling --with-unwind=/apps/BSCTOOLS/deps/libunwind/1.2.1 
#--with-xml-prefix=/apps/BSCTOOLS/deps/libxml/2.9.4

%install

export NO_BRP_CHECK_RPATH=true

# OpenHPC compiler designation
%ohpc_setup_compiler

%ifarch x86_64
module load papi
%endif

make DESTDIR=$RPM_BUILD_ROOT install

# don't package static libs
rm -f $RPM_BUILD_ROOT%{install_path}/lib/*.la
rm -f $RPM_BUILD_ROOT%{install_path}/lib/*.a

# OpenHPC module file
%{__mkdir} -p %{buildroot}%{OHPC_MODULEDEPS}/%{compiler_family}-%{mpi_family}/%{pname}
%{__cat} << EOF > %{buildroot}/%{OHPC_MODULEDEPS}/%{compiler_family}-%{mpi_family}/%{pname}/%{version}
#%Module1.0#####################################################################

proc ModulesHelp { } {

puts stderr " "
puts stderr "This module loads the %{pname} library built with the %{compiler_family} compiler"
puts stderr "toolchain and the %{mpi_family} MPI stack."
puts stderr "\nVersion %{version}\n"

}
module-whatis "Name: %{pname} built with %{compiler_family} compiler and %{mpi_family} MPI"
module-whatis "Version: %{version}"
module-whatis "Category: performance tool"
module-whatis "Description: %{summary}"
module-whatis "URL %{url}"

set     version			    %{version}



prepend-path    PATH                %{install_path}/bin
prepend-path    MANPATH             %{install_path}/share/man
prepend-path    INCLUDE             %{install_path}/include
prepend-path	LD_LIBRARY_PATH	    %{install_path}/lib

setenv          %{PNAME}_DIR        %{install_path}
setenv          %{PNAME}_LIB        %{install_path}/lib
setenv          %{PNAME}_INC        %{install_path}/include

EOF

%ifarch x86_64
echo "depends-on papi" >> %{buildroot}/%{OHPC_MODULEDEPS}/%{compiler_family}-%{mpi_family}/%{pname}/%{version}
%endif

%{__cat} << EOF > %{buildroot}/%{OHPC_MODULEDEPS}/%{compiler_family}-%{mpi_family}/%{pname}/.version.%{version}
#%Module1.0#####################################################################
##
## version file for %{pname}-%{version}
##
set     ModulesVersion      "%{version}"
EOF

%{__mkdir} -p $RPM_BUILD_ROOT/%{_docdir}


%files
%defattr(-,root,root,-)
%{OHPC_HOME}
%{OHPC_PUB}

%doc



%changelog
